#include <bits/stdc++.h>
using namespace std;

const int maxn = 100000;
int n, v, e;
vector <int> adj_t [maxn], adj_g [maxn];
int par [maxn], depth [maxn], color [maxn];
vector <int> colored;
bool used [maxn];

void root_t (int a){
    for (int i : adj_t [a]){
        if (i != par [a]){
            par [i] = a;
            depth [i] = depth [a] + 1;
            root_t (i);
        }
    }
}

vector <int> path;
void set_colors (){
    int c1 = color [path [0]], c2 = color [path.back ()];
    int x = (path.size () + depth [c1] - depth [c2] + 1) / 2;
    int curr = c1;
    for (int i = 1; i < x; i ++){
        curr = par [curr];
        color [path [i]] = curr;
        colored.push_back (path [i]);
    }
    curr = c2;
    for (int i = path.size () - 2; i >= x; i --){
        curr = par [curr];
        color [path [i]] = curr;
        colored.push_back (path [i]);
    }
}
bool dfs (int a){
    used [a] = 1;
    path.push_back (a);
    if (color [a] != -1 && !path.empty ()){
        set_colors ();
        path.pop_back ();
        return 1;
    }
    for (int i : adj_g [a]){
        if (used [i] && color [i] == -1) continue;
        if (dfs (i) && path.size () > 1){
            path.pop_back ();
            return 1;
        }
    }
    path.pop_back ();
    return 0;
}

void dfs2 (int a){
    for (int i : adj_g [a]){
        if (color [i] != -1) continue;
        if (depth [color [a]] % 2 == 0) color [i] = adj_t [color [a]][0];
        else color [i] = par [color [a]];
        dfs2 (i);
    }
}

vector <int> solve (int N, int V, int E, vector <int> A, vector <int> B, vector <int> X, vector <int> Y){

    n = N;
    v = V;
    e = E;
    for (int i = 0; i < n; i ++) adj_t [i].clear ();
    for (int i = 0; i < n - 1; i ++){
        adj_t [A [i]].push_back (B [i]);
        adj_t [B [i]].push_back (A [i]);
    }
    for (int i = 0; i < v; i ++) adj_g [i].clear (), used [i] = 0;
    for (int i = 0; i < e; i ++){
        adj_g [X [i]].push_back (Y [i]);
        adj_g [Y [i]].push_back (X [i]);
    }
    par [0] = -1;
    root_t (0);

    colored.clear ();
    for (int i = 0; i < n; i ++) color [i] = i, colored.push_back (i);
    for (int i = n; i < v; i ++) color [i] = -1;
    for (int i : colored) dfs (i);
    for (int i = 0; i < v; i ++) if (color [i] != -1) dfs2 (i);

    vector <int> ans;
    for (int i = 0; i < v; i ++) ans.push_back (color [i]);
    return ans;

}
/*
int main (){

    vector <int> colors = solve (2, 4, 2, {0}, {1}, {2, 3}, {0, 1});
    for (int i : colors) cout << i << ' ';
    cout << '\n';

    colors = solve (4, 5, 3, {0, 0, 0}, {1, 2, 3}, {1, 2, 3}, {4, 4, 4});
    for (int i : colors) cout << i << ' ';
    cout << '\n';

    colors = solve (3, 4, 2, {0, 1}, {1, 2}, {3, 3}, {0, 2});
    for (int i : colors) cout << i << ' ';
    cout << '\n';

}
*/
