#include <iostream>
#include <cstring>
#include <vector>

using namespace std;

const int MAXN = 2e5 + 5;
const long long mod = 1e9 + 7;

void rotate45(vector <vector<int>> &A)
{
    int n = A.size();
    int m = A[0].size();

    vector <vector <int>> B;
    B.resize(m);

    for(int j = 0;j<m;j++)
    {
        for(int i = n-1;i>=0;i--)
        {
            B[j].push_back(A[i][j]);
        }
    }

    A = B;
}

//int16_t andVals[MAXN];

int solve(vector<int> P, int n, int m, vector<vector<int>> A)
{
    bool v[MAXN];

    if(n>m)
    {
        swap(n, m);
        rotate45(A);
    }

    /*
    #ifdef LOCAL
    for(int i = 0;i<n;i++)
    {
        for(int x: A[i]) cout << x << " ";
        cout << '\n';
    }
    #endif // LOCAL
    */

    long long sum = 0;
    for(int bit = 0;bit<10;bit++)
    {
        for(int r1 = 0;r1<n;r1++)
        {
            //vector <int> andVals(m, 0);
            //memset(andVals, 0, sizeof(int16_t)*(m+1));
            memset(v, 0, sizeof(bool)*(m+1));

            for(int r2 = r1;r2<n;r2++)
            {
                //for(int c = 0;c<m;c++) andVals[c] |= A[r2][c];
                //for(int c = 0;c<m;c++) v[c] = ((andVals[c]>>bit)&1);
                //for(int c = 0;c<m;c++) v[c] |= ((A[r2][c]>>bit)&1);

                /*
                int r = -1, cnt = 0;
                for(int l = 0;l<m;l++)
                {
                    if(r<l)
                    {
                        r = l;
                        cnt = v[l];
                    }
                    while(cnt==0 && r<m) r++, cnt += v[r];

                    if(cnt>0)
                        sum = (sum + (1LL<<bit)*(m - r));

                    cnt -= v[l];
                }
                */

                int last = -1;
                for(int i = 0;i<m;i++)
                {
                    v[i] |= ((A[r2][i]>>bit)&1);
                    if(v[i])
                    {
                        sum = (sum + (1LL<<bit)*(i-last)*(m-i));
                        last = i;
                    }
                }
                sum %= mod;
            }
        }
    }

    return sum;
}

#ifdef LOCAL

int main()
{
    vector <int> P;
    for(int i = 0;i<1024;i++) P.push_back(i);

    /*
    int x = solve(P,
            3, 3,
            {{1, 2, 3},
            {1, 2, 3},
            {1, 2, 3}});
    */

    int n = 450, m = 450;
    vector <vector <int>> A(n);
    for(int i = 0;i<n;i++)
        for(int j = 0;j<m;j++)
            A[i].push_back(1023);


    int x = solve(P,
                  4, 5,
                  {{537, 152, 39, 245, 765},
                  {487, 748, 533, 897, 881},
                  {980, 571, 568, 972, 894},
                  {88, 901, 637, 47, 822}});



    //int x = solve(P, n, m, A);

    cout << x << '\n';
}

#endif // LOCAL
