#include <algorithm>
#include <iostream>
#include <assert.h>
#include <vector>

using namespace std;

const int MAXN = 1e5 + 5;

vector <int> tAdj[MAXN], gAdj[MAXN];

std::vector<int> solve(int N, int V, int E,
                       vector<int> A, vector<int> B,
                       vector<int> X, vector<int> Y)
{
    vector <int> c(V, -1);
    for(int i = 0;i<N;i++) c[i] = i;

    for(int i = 0;i<N-1;i++)
    {
        tAdj[A[i]].push_back(B[i]);
        tAdj[B[i]].push_back(A[i]);
    }
    for(int i = 0;i<E;i++)
    {
        gAdj[X[i]].push_back(Y[i]);
        gAdj[Y[i]].push_back(X[i]);
    }

    for(int x = 0;x<N;x++) sort(tAdj[x].begin(), tAdj[x].end());
    for(int x = 0;x<V;x++) sort(gAdj[x].begin(), gAdj[x].end());

    for(int iter = 0;iter<V-N;iter++)
    {
        vector <vector <int>> options;
        options.resize(V);

        for(int x = 0;x<V;x++)
        {
            if(c[x]!=-1) continue;

            for(int op = 0;op<N;op++)
            {
                bool fail = false;
                for(int y: gAdj[x])
                {
                    if(c[y]!=-1)
                    {
                        if(binary_search(tAdj[c[y]].begin(), tAdj[c[y]].end(), op)==false)
                        {
                            fail = true;
                            break;
                        }
                    }

                    if(fail==true) break;
                }

                if(fail==false)
                {
                    options[x].push_back(op);
                }
            }
        }

        int node = -1;
        for(int x = 0;x<V;x++)
        {
            if(c[x]!=-1) continue;

            if(node==-1 || options[x].size()<options[node].size())
                node = x;
        }


        assert(options[node].size()!=0);
        c[node] = options[node].back();
    }

    return c;
}

#ifdef LOCAL

int main()
{
    vector <int> v;

    //v = solve(2, 4, 2, {0}, {1}, {2, 3}, {0, 1});
    //v = solve(4, 5, 3, {0, 0, 0}, {1, 2, 3}, {1, 2, 3}, {4, 4, 4});
    v = solve(3, 4, 2, {0, 1}, {1, 2}, {3, 3}, {0, 2});

    for(int x: v) cout << x << " ";
    cout << '\n';
}

#endif // LOCAL
