#include <algorithm>
#include <iostream>
#include <assert.h>
#include <vector>
#include <random>

using namespace std;

mt19937 rnd(22);
const int MAXN = 1e5 + 5;

int parent[MAXN];
vector <int> tAdj[MAXN], gAdj[MAXN];

bool used[MAXN];

void dfs(int x, int col, vector <int> &c)
{
    c[x] = col;
    used[x] = true;

    for(int y: gAdj[x])
    {
        if(used[y]==false)
        {
            dfs(y, col^1, c);
        }
    }
}

bool checkAnswer(int N, int V, const vector <int> &c)
{
    for(int x = 0;x<V;x++)
    {
        for(int y: gAdj[x])
        {
            if(y<x) continue;
            if(binary_search(tAdj[c[y]].begin(), tAdj[c[y]].end(), c[x])==false) return false;
        }
    }

    return true;
}

std::vector<int> solve(int N, int V, int E,
                       vector<int> A, vector<int> B,
                       vector<int> X, vector<int> Y)
{
    for(int x = 0;x<V;x++)
    {
        used[x] = false;
        tAdj[x].clear();
        gAdj[x].clear();
    }

    vector <int> c(V, -1);
    for(int i = 0;i<N;i++) c[i] = i;

    for(int i = 0;i<N-1;i++)
    {
        tAdj[A[i]].push_back(B[i]);
        tAdj[B[i]].push_back(A[i]);
    }
    for(int i = 0;i<E;i++)
    {
        gAdj[X[i]].push_back(Y[i]);
        gAdj[Y[i]].push_back(X[i]);
    }

    for(int x = 0;x<N;x++) sort(tAdj[x].begin(), tAdj[x].end());
    for(int x = 0;x<V;x++) sort(gAdj[x].begin(), gAdj[x].end());

    for(int x = 0;x<V;x++)
    {
        if(used[x]==false)
        {
            dfs(x, (x==1), c);
        }
    }

    return c;
}

#ifdef LOCAL

int main()
{
    vector <int> v;

    v = solve(2, 4, 2, {0}, {1}, {2, 3}, {0, 1});
    //v = solve(4, 5, 3, {0, 0, 0}, {1, 2, 3}, {1, 2, 3}, {4, 4, 4});
    //v = solve(3, 4, 2, {0, 1}, {1, 2}, {3, 3}, {0, 2});

    for(int x: v) cout << x << " ";
    cout << '\n';
}

#endif // LOCAL
